import c4d

doc: c4d.documents.BaseDocument  # The currently active document.
op: c4d.BaseObject | None  # The primary selected opect in `doc`. Can be `None`.

def bake():

    strength_list = {
        "AA": 1,
        "EE": 1,
        "IY": 1,
        "OW": 1,
        "UW": 1,
        "F": 1,
        "W": 1,
        "SH": 1,
        "T": 1,
        "M": 1
    }

    after_list = []

    # =================================================

    user_list = ["AA", "EE", "IY", "OW", "UW", "F", "W", "SH", "T", "M"]

    parameter_list = []

    for ide, bc in op.GetUserDataContainer():
        if bc[c4d.DESC_NAME] in user_list:
            parameter_list.append(ide)
            after_list.append(bc[c4d.DESC_NAME])

    if not parameter_list:  # if no userdatas added
        c4d.gui.MessageDialog("Missing User Datas!\n\nClick 'Add User-Data'")
        return True

    doc.AddUndo(c4d.UNDOTYPE_CHANGE, op)
    c4d.StatusSetSpin()
    # start = node[PY_BAKE_START]
    # end = node[PY_BAKE_END]

    for frame in range(0, 90):

        time = c4d.BaseTime(frame, doc.GetFps())

        doc.SetTime(time)

        doc.ExecutePasses(None, True, True, True,
                          c4d.BUILDFLAGS_NONE)  # False True False

        for ide in parameter_list:
            track = op.FindCTrack(ide)

            if track is None:
                track = c4d.CTrack(op, ide)
                op.InsertTrackSorted(track)

            curve = track.GetCurve()
            keyData = curve.AddKey(time)

            if keyData is None:
                raise RuntimeError("Could not add key frame.")

            key = keyData["key"]

            key.SetValue(curve, op[ide])

            key[c4d.ID_CKEY_PRESET] = 2  # c4d.ID_CKEY_PRESET_AUTO_OVERSHOOTWEIGHTED

    c4d.StatusClear()

def main() -> None:
    """Called by Cinema 4D when the script is being executed.
    """
    bake()


if __name__ == '__main__':
    main()